diff a/src/hotspot/share/interpreter/interpreterRuntime.cpp b/src/hotspot/share/interpreter/interpreterRuntime.cpp
--- a/src/hotspot/share/interpreter/interpreterRuntime.cpp
+++ b/src/hotspot/share/interpreter/interpreterRuntime.cpp
@@ -737,19 +737,25 @@
     if ((is_put && !has_initialized_final_update) || !info.access_flags().is_final()) {
       put_code = ((is_static) ? Bytecodes::_putstatic : Bytecodes::_putfield);
     }
   }
 
+  bool is_tsan_ignore = false;
+#if INCLUDE_TSAN
+  is_tsan_ignore = info.access_flags().is_stable() || info.access_flags().is_tsan_ignore();
+#endif  // INCLUDE_TSAN
+
   cp_cache_entry->set_field(
     get_code,
     put_code,
     info.field_holder(),
     info.index(),
     info.offset(),
     state,
     info.access_flags().is_final(),
     info.access_flags().is_volatile(),
+    is_tsan_ignore,
     pool->pool_holder()
   );
 }
 
 
